<?php
/**************************************************************************
* PHP Analg ra 1.0                                                      *
* ======================================================================= *
* Ez a PHP-val formzott, grafikus analg ra a szerver idt mutatja      *
* Az mutatk frissitse a bngsz frisstsvel rhet el                *
* Minden tulajdonsga szemlyre szabhat a fjlban, vagy URL parancsokkal *
* ======================================================================= *
* Ezt a programot a PHP Studio fejlesztette, a szerzk: / This program    *
* was developed by the PHP Studio, the authors:                           *
* Rimelek (http://rimelek.hu)                                                                *
* ----------------------------------------------------------------------- *
* Weboldalunk / Our webpage: http://www.phpstudio.hu                      *
* Segtsgnyjts / HelpDesk: http://forum.phpstudio.hu                   *
* Kapcsolat / Contact: php.prog@hotmail.com                               *
* ======================================================================= *
* Ez a program license alatt ll, amit itt tekinthetsz meg: / This        *
* program is under a license, which you can see here:                     *
* http://license.phpstudio.hu                                             *
* ----------------------------------------------------------------------- *
* A license-szel kapcsolatos szrevteleid, megjegyzseid, krdseid  a   *
* license@phpstudio.hu e-mail cmen vrjuk.                               *
* ----------------------------------------------------------------------- *
* You can send your remarks, opinions, questions to the following e-mail  *
* address: license@phpstudio.hu                                           *
* ======================================================================= *
* Dtum / Date: 2007.02.22                                                *
**************************************************************************/

/******************************* BELLTSOK *******************************/
/**************** Itt tudod szemlyre szabni az ra tulajdonsgait *********/
/**************** Vagy a readme.txt-ben ismertetett URL parancsokkal ********/

$type = 'gif';                   //a ksztett kp formtuma
$D = '150';                      // Az ra tmrje

$colors['bg']   = '100,100,160'; //Az ralap szne
$colors['hour'] = '200,10,60';   //ra mutat szne
$colors['min']  = '100,200,250'; //perc mutat szne
$colors['sec']  = '20,200,30';   //msodperc mutat szne
$colors['kor']  = '0,0,0';       //az ra szeglynek szne
$colors['lap']  = '0,0,0';       //Az rn a beosztsok, s a kzpont szne

//Az ralapot terletn kivli httrszn. 
//gif, vagy png kiterjesztsekkel Ez a terlet tltsz marad
$colors['transparent'] = '0,0,1';



/********************** Innentl ne vltoztass semmit **********************/
/****************** Mert a program meghibsodst okozhatja ****************/



class Analog_Ora
{
    //az id, a sznek, s a kp azonost vltozi
    var $ido = array();
    var $colors = array();
    var $image;
    
    //A program ltal hasznlt vltozk belltsa
    //A fejlc (header) kittele
    function Analog_Ora($image_type,$D)
    {
        $this->ido['ora12'] = date("h");
        $this->ido['ora24'] = date("H");
        $this->ido['perc']  = date("i");
        $this->ido['mperc'] = date("s");
        $this->ido['am_pm'] = date("A");
        
        $this->ora_header($image_type,$D);
    }
    
    //A kp fejlc ltrehozsa a tpustl fggen
    function ora_header($image_type,$D)
    {
        header('Content-type: image/'.$image_type);
        $this->image = ImageCreate($D,$D);
    }

    //A program ltal hasznlt sszes szn tadsa az objektumnak
    function set_colors($colors)
    {

        foreach($colors as $key => $value)
        {
            if(isset($_GET[$key]) and $_GET[$key] != '') { $value = $_GET[$key]; }
            $szinek = explode(',',$value);
            $this->colors[$key]['R'] = $szinek[0];
            $this->colors[$key]['G'] = $szinek[1];
            $this->colors[$key]['B'] = $szinek[2];
        }

    }

    //Az ralap 'nem mozg' elemei
    function ora_lap($D,$kor,$lap)
    {
        //Az ralapot hatrol kr ltrehozsa
        ImageArc($this->image,round($D/2),round($D/2),$D-1,$D-1,0,360,$kor);
        //Az ra, s perc beosztsok kirajzolsa
        $this->osztasok($D,$lap);
        //A 'dlutn' (PM), vagy 'dleltt' (AM) jelzse
        ImageString($this->image,2,round($D/2)-3,round($D/4),$this->ido['am_pm'],$lap);
 
    }

    //Az ra s perc beosztsok kirajzolsa
    function osztasok($D,$lap)
    {
        $ora = 1;
        //0 -tl 360 fokig, teht a kr teljes terletn az osztsok rajzolsa
        for($i=0; $i<360; $i=$i+6)
        {
            //Az adott szg meghatrozsa radinban fok-bl tvltva
            $fok1 = deg2rad($i) - deg2rad(60);
            
            //A perc osztsok
            if(($i % 30)){
            $kx0 = ((($D / 2) - 5) * cos($fok1)) + $D/2;
            $ky0 = ((($D / 2) - 5) * sin($fok1)) + $D/2;

            ImageFilledArc($this->image, round($kx0), round($ky0), 3,3, 0, 360, $lap, IMAGE_ARC_PIE);
            //Az ra osztsok
            }else{

            $kx0 = ((($D / 2) -2) * cos($fok1)) + $D/2;
            $ky0 = ((($D / 2) -2) * sin($fok1)) + $D/2;

            $kx = ((($D / 2) -10) * cos($fok1)) + $D/2;
            $ky = ((($D / 2) -10) * sin($fok1)) + $D/2;

            $kx1 = ((($D / 2) -17) * cos($fok1)) + $D/2 - 3;
            $ky1 = ((($D / 2) -17) * sin($fok1)) + $D/2 - 5;

            imageLine($this->image, round($kx0), round($ky0), round($kx), round($ky), $lap);
            //Az ra osztsok mellett az ra szma
            ImageString($this->image,2,round($kx1),round($ky1),$ora,$lap);
            $ora++;
            }
        }
    }
    
    //A mutatk kirajzolsa
    function mutatok($D,$hour,$hl,$min,$ml,$sec,$sl)
    {
        $this->hour_mut($D,$hour,$hl); //ra
        $this->min_mut($D,$min,$ml);   //perc
        $this->sec_mut($D,$sec,$sl);   //msodperc
    }

    //ra mutat ltrehozsa
    function hour_mut($D,$color,$arany)
    {
        //ra mutat pozicija
        $orafok = deg2rad( 30 * $this->ido['ora12'] ) - deg2rad(90) + deg2rad($this->ido['perc']/2);
        $orax = ((($D/2)*$arany) * cos($orafok)) + $D/2;
        $oray = ((($D/2)*$arany) * sin($orafok)) + $D/2;

        //ra mutat
        imageLine($this->image, round($D/2), round($D/2), round($orax), round($oray), $color);
    }
    
    //perc mutat ltrehozsa
    function min_mut($D,$color,$arany)
    {
        //a perc mutat pozicija
        $percfok = deg2rad( 6 * $this->ido['perc'] ) - deg2rad(90) + deg2rad($this->ido['mperc']/10);
        $percx = ((($D/2)*$arany) * cos($percfok)) + $D/2;
        $percy = ((($D/2)*$arany) * sin($percfok)) + $D/2;
        
        //perc mutat
        imageLine($this->image, round($D/2), round($D/2), round($percx), round($percy), $color);
    }
    
    //Msodperc mutat ltrehozsa
    function sec_mut($D,$color,$arany)
    {
        //a msodperc pozicijnak szmtsa
        $mpfok = deg2rad( 6 * $this->ido['mperc'] ) - deg2rad(90);
        $mpx = ((($D/2)*$arany) * cos($mpfok)) + $D/2;
        $mpy = ((($D/2)*$arany) * sin($mpfok)) + $D/2;

        //Msodperc mutat
        imageLine($this->image, round($D/2), round($D/2), round($mpx), round($mpy), $color);
    }
    

    
}

//Az tmr mdostsa az url-bl
$D = (isset($_GET['D']) and $_GET['D'] != "") ? $_GET['D'] : $D;
//A kp tpusnak mdostsa url-bl
$type = (isset($_GET['type']) and $_GET['type'] != "") ? $_GET['type'] : $type;

//Objektum ltrehozsa
$ora = new Analog_Ora($type,$D);
//A sznek R,G,B komponenseinek tmbbe rendezse.tadsa az objektumnak
$ora->set_colors($colors);
//Az sszes megadott szn definilsa, s ltrehozsa
foreach($colors as $key=>$value)
{
$$key = ImageColorAllocate(
            $ora->image,
            $ora->colors[$key]['R'],
            $ora->colors[$key]['G'],
            $ora->colors[$key]['B']
            );
}

//ralap kirajzolsa
$ora->ora_lap($D,$kor,$lap);
//Mutatk kirajzolsa
$ora->mutatok($D,$hour,0.5,$min,0.7,$sec,0.8);

//a kzppontban egy tmtt karika
ImageFilledArc($ora->image, $D/2, $D/2, 5,5, 0, 360, $lap, IMAGE_ARC_PIE);

//Az rt krlvev httrszn beltsa, ha nem gif, vagy png a kiterjeszts
imageFill($ora->image,0,0,$transparent);
//gif, vagy png kiterjesztsek esetn a httrszn elrejtse, ttetszv ttele
imageColorTransparent($ora->image,$transparent);
//Tpus meghatrozs, a ksz kp kirajzolsa a bngszben
$func = 'image'.$type;
$func($ora->image);
?>
